#!/usr/local/bin/perl
#
# unagi script ver. 0.60 extended (c) unagi 2001, 204504byse 2007
#
# contact: http://www.204504byse.info/
#          mailto:204504byse@204504byse.info
#
#
use strict;
require './common.pl';

require 'BaseCalc.pl';
my $calc = new Math::BaseCalc(digits => [0..9]);# 10i,

# ݒuOɈȉ̐ݒD݂ɉĕςĂ

# 蓮ōL^O}ꍇ͂Őݒ
my $ad_header = <<HTML; # y[W̐擪̍L
HTML
my $ad_footer = <<HTML; # y[W̖̍L
HTML

# ȉ̐ݒ͗ǂȂΕςȂł
my $index = "index2.html";
my $root = '..';
my $cookiepath = "";
my $cgidir = '.';

# O[oϐ̐錾
my %in;
my %cookie;
my $cookiestr = "";

# ̓p[^̉
{
	my $query;
	if ($ENV{'REQUEST_METHOD'} eq 'GET') {
		$query = $ENV{'QUERY_STRING'};
	} elsif ($ENV{'REQUEST_METHOD'} eq 'POST') {
		if ($ENV{'CONTENT_LENGTH'} > 5000) {
			&error("G[", "͂傫܂");
		}
		read(STDIN, $query, $ENV{'CONTENT_LENGTH'});
	}
	my @query = split(/&/, $query);
	foreach (@query) {
		my ($key, $val) = split(/=/);
		$in{$key} = $val;
	}
}
$in{search} =~ tr/+/ /;
$in{search} =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack("c", hex($1))/ge;
$in{search} =~ s/@/ /g;
my @keywords = split(/\s+/, $in{search});

# SETTING.TXT̐ݒǂݍ
my $cookiemethod = $calc->from_base(getini("$root/$in{bbs}/SETTING.TXT", 'cookiemethod'));	# ǃNbL[s̕@, 0 = sȂ, 1 = Set-Cookie:, 2 = meta^O
my $ls = $calc->from_base(getini("$root/$in{bbs}/SETTING.TXT", 'ls'));			# ŐVn\[hŕ\铊e̐
my $displaydatsize = $calc->from_base(getini("$root/$in{bbs}/SETTING.TXT", 'displaydatsize'));#dat̃t@CTCY\邩ǂ, 0 = \Ȃ, 1 = \
my $usejs = $calc->from_base(getini("$root/$in{bbs}/SETTING.TXT", 'usejs'));	# JavaScriptgpit[T[oȂǂ̍L}ƑƂ0ɂj
	# 1ɂ
	# EO^[̃NbL[ۑ
	# EdM̃~Xh~@\
	# EԐM@\
	# LɂȂ܂


# NbL[̎擾
my @cookie = split(/ /, $ENV{'HTTP_COOKIE'});
foreach (@cookie) {
	my ($key, $val) = split(/=/);
	$val =~ s/(.*);$/$1/;
	$cookie{$key} = $val;
}
my $imode = ($ENV{'HTTP_USER_AGENT'} =~ m/DoCoMo/) || ($in{imode} == 1);
if ($imode) {
	$ls = 3;
}

# ͏̃`FbN
if (!$in{bbs} || ($in{bbs} =~ m/[^A-Za-z0-9_]+/g) || !(-d "$root/$in{bbs}")) {
	undef $in{bbs};
	&error("G[", "bbs̒lsł");
}
if (!$in{key} || ($in{key} =~ m/[^A-Za-z0-9_]+/g)) {
	undef $in{key};
	&error("G[", "key̒lsł", "$root/$in{bbs}/$index");
}
if ($in{st} =~ m/[^[0-9]+/g) {
	undef $in{st};
}
if ($in{to} =~ m/[^[0-9]+/g) {
	undef $in{to};
}
my $key = "$in{bbs}_$in{key}";
if ($cookie{$key} =~ m/[^[0-9]+/g) {
	undef $cookie{$key};
}


# Xbht@CJ
if (!open(DAT, "$root/$in{bbs}/dat/$in{key}.dat")) {
	&error("G[", "Xbh܂", "$root/$in{bbs}/$index");
}
eval {flock DAT, 1;};
my $filesize = (-s DAT);
my $writable = (-w DAT);
my $input = <DAT>;
chomp $input;
my @msg = split(/<>/, $input);

# NbL[̐ݒ
my @week = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
my @month = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
my ($second, $minute, $hour, $day, $mon, $year, $wday) = gmtime(time + 60 * 60 * 24 * 30); # L1
my $gmt = sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT", $week[$wday], $day, $month[$mon], $year + 1900, $hour, $minute, $second);
if (!$in{search} && !$in{to} && $filesize > $cookie{$key}) {
	if ($cookiepath eq "") {
		my @path = split(/\//, $ENV{'SCRIPT_NAME'});
		my $i;
		for ($i = 0; $i < @path - 2; $i++) {
			$cookiepath .= $path[$i] . '/';
		}
	}
	if ($cookiemethod == 1) {
		print "Set-Cookie: $in{bbs}_$in{key}=$filesize; path=$cookiepath; expires=$gmt\n";
	} elsif ($cookiemethod == 2) {
		$cookiestr = "$in{bbs}_$in{key}=$filesize; path=$cookiepath; expires=$gmt";
	}
}

# oHTML̃wb_
print <<HTML;
Content-type: text/html; charset=Shift_JIS

<html lang="ja">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=Shift_JIS">
<link rel=stylesheet type="text/css" href="$root/$in{bbs}/unagi.css">
HTML
if ($cookiemethod == 2 && $cookiestr ne "") {
	print "<meta http-equiv=\"Set-Cookie\" content=\"$cookiestr\">";
}
if ($usejs) {
	print "<meta http-equiv=\"Content-Script-Type\" content=\"text/javascript\">\n";
	print "<script type=\"text/javascript\" src=\"$cgidir/unagi.js\"></script>\n";
}
print <<HTML;
<title>$msg[4]</title>
</head>
<body class="thread">
$ad_header
<a name="top"></a>
HTML

# 㕔irQ[VN
if (!$imode) {
	print "<form method=GET action=\"read.cgi\">\n";
	print "<a href=\"$root/$in{bbs}/$index\">[fɖ߂]</a>\n";
	print "<input type=\"hidden\" name=\"bbs\" value=$in{bbs}><input type=\"hidden\" name=\"key\" value=$in{key}>[<input type=\"text\" name=\"search\" size=\"10\" value=\"$in{search}\"><input type=\"submit\" value=\"\">]\n";
	print "<a href=\"#bottom\">[]</a>\n";
	print "</form>\n";
} else {
#	print "<div>\n";
#	print "<a href=\"$root/test/all.cgi?bbs=$in{bbs}&amp;imode=1\" accesskey=\"5\">[fɖ߂]</a>\n";
#	print "</div>\n";
}

print "<h1 class=\"subject\">$msg[4]</h1>\n";

# \[h̏
{
	my $msg = "";
	if (!$writable) {
		$msg .= "<li>̃Xbh͏ݏo܂</li>\n";
	}
	if ($in{search}) {
		$msg .= "<li>Xbh <b>$in{search}</b> Ōʂ\\܂</li>\n";
	} elsif ($cookie{$key} && !$in{st} && !$imode) {
		$msg .= "<li>Xbh̖Ǔe\\܂</li>\n";
	} elsif (!$cookie{$key} && !$in{st} && !$imode) {
		$msg .= "<li>ŐV$ls\\[hł</li>\n";
	}
	if ($msg) {
		print "<ul>\n$msg</ul>\n";
	}
}

print "<ol>\n";
my $i = 0;
my $st = 0; my $to = 0; my $more = 0;
if (!$cookie{$key} && !$in{st} && !$in{search}) {
	my @dat;
	do {
		push @dat, $input;
	} while ($input = <DAT>);
#	my $j;
	$st = @dat - $ls + 1;
	$st = ($st < 1) ? 1 : $st;
	$to = int(@dat);
	for ($i = 0; $i < @dat; $i++) {
		if ($i + 1 >= $st) {
			@msg = split(/<>/, $dat[$i]);
			&printmsg($msg[0], $msg[1], $msg[2], $msg[3], $i + 1, ($writable && $usejs));
		}
	}
	$more = 0;
} else {
	my $count = 0;
	do {
		$i++;
		my $display = 0;
		@msg = split(/<>/, $input);
		# $iԖڂ̔\邩ǂ̌
		if ($in{search}) {
			# ꂪw肳ĂȂ}b`ꍇɕ\
			my $j;
			for ($j = 0; $j < @keywords; $j++) {
				if ($input =~ m/\Q$keywords[$j]\E/i) {
					$display = 1;
					last;
				}
			}
		} else {
			if (($in{st} && $i >= $in{st}) || (!$in{st} && tell(DAT) > $cookie{$key}) || eof(DAT)) {
				if ($st == 0) {
					$st = $i;
				}
				$display = 1;
			}
		}
		# 폜Ă锭͔΂
		#$display &= ($msg[2] ne 'deleted');
		if ($display) {
			&printmsg($msg[0], $msg[1], $msg[2], $msg[3], $i, ($writable && $usejs));
			$count++;
		}
		if ($in{to} && $i >= $in{to}) {
			$more = 1;
			seek DAT, 0, 2;
		}
		if ($imode && ($count >= $ls)) {
			if (!eof(DAT)) {
				$more = 1;
			}
			seek DAT, 0, 2;
		}
	} while ($input = <DAT>);
	$to = $i;
}


print "</ol>\n";


# oHTML̃tb^
#datTCY̕\
if($displaydatsize) {
	my @datstat = stat(DAT);
	$datstat[7] = int($datstat[7] / 1024);
	printf ("<font color=\"red\" size=\"4\"><b>%d KB</b></font><br><br>",$datstat[7]);
}
close DAT;
# ݃tH[
if ($writable) {
	printf "<form method=POST action=\"bbs.cgi\" name=\"frm0\" %s>\n", $usejs ? "onSubmit=\"return send(this)\"" : "";
	print "<input type=hidden name=bbs value=$in{bbs}>\n";
	print "<input type=hidden name=key value=$in{key}>\n";
	print "<a name=\"bottom\" accesskey=\"0\">O</a> <input type=text name=FROM size=15 value=\"\">\n";
	print "[ <input type=text name=mail size=15 value=\"\"><br>\n";
	print "<textarea rows=5 cols=54 name=MESSAGE></textarea><br>\n";
	print "<input type=submit value=\"\" name=submit>\n";
	print "</form>\n";
	if ($usejs) {
		print "<script type=\"text/javascript\">\n";
		print "<!--\n";
		print "document.forms['frm0'].FROM.value = from;\n";
		print "document.forms['frm0'].mail.value = mail;\n";
		print "//-->\n";
		print "</script>\n";
	}
}
# irQ[VN
print "<form method=GET action=\"read.cgi\">\n";
if ($st > 1) {
	my $newto = $st - 1;
	my $newst = $st - $ls;
	$newst = ($newst < 1) ? 1 : $newst;
	printf "<a href=\"read.cgi?bbs=%s&amp;key=%s&amp;st=%s&amp;to=%s%s\" accesskey=\"4\">[%sO]</a>\n", $in{bbs}, $in{key}, $newst, $newto, $imode ? "&amp;imode=1" : "", $imode ? "\xf9\x8a" : "";
}
if ($more) {
	my $newst = $to + 1;
	printf "<a href=\"read.cgi?bbs=%s&amp;key=%s&amp;st=%s%s\" accesskey=\"6\">[%s]</a>\n", $in{bbs}, $in{key}, $newst, $imode ? "&amp;imode=1" : "", $imode ? "\xf9\x8c" : "";
}
if ($imode) {
	print "<a href=\"$root/test/all.cgi?bbs=$in{bbs}&amp;imode=1\" accesskey=\"5\">[\xf9\x8bfɖ߂]</a>\n";
} else {
	print "<a href=\"$root/$in{bbs}/$index\">[fɖ߂]</a>\n";
	print "<a href=\"read.cgi?bbs=$in{bbs}&amp;key=$in{key}&amp;st=1\">[Sēǂ]</a>\n";
	print "<input type=hidden name=bbs value=$in{bbs}><input type=hidden name=key value=$in{key}>[<input type=text name=st size=4 value=\"\">ȍ~<input type=submit value=\"ǂ\">]\n";
	print "<a href=\"#top\">[]</a>\n";
}
print "</form>\n";

print copyright();
print <<HTML;
$ad_footer
</body>
</html>
HTML

# ܂
exit;

# printmsg O, [, t, Rg, ԍ, ԐM{^̕\
sub printmsg {
	my $i = $_[4];
	my $displayreplybutton = $_[5];
	print "<li value=\"$i\">\n";
	if ($_[1] eq '') {
		print "<span class=\"name\"><b>$_[0]</b></span>\n";
	} else {
		print "<a href=\"mailto:$_[1]\" class=\"mail\"><b>$_[0]</b></a>\n";
	}
	if (!$imode) {
		print "<span class=\"date\">$_[2]</span>\n";
		if ($displayreplybutton) {
			print "<script type=\"text/javascript\">\n";
			print "<!--\n";
			#print "document.write(\"<a href=\\\"#bottom\\\" onClick=\\\"reply('0', '$i')\\\">[ԐM]<\\/a>\");\n";
			print "//-->\n";
			print "</script>\n";
		}
	}
	$_[3] =~ s/&gt;&gt;([\d][\d-]*)/refer($in{bbs}, $in{key}, $1, $cgidir)/eg;
	$_[3] =~ s/([^\"]|^)(http\:[\w\.\~\+\-\/\?\&\=\@\;\#\:\%\,]+)/$1.httplink($2)/eg;
	#$_[3] =~ s/\[google\]([^<]+)(<|$)/google($1).$2/eg;
	print "<p id=\"msg0.$i\">$_[3]</p>\n";
	if ($imode) {
		print "<div class=\"date\">$_[2]</div>\n<hr>\n";
	}
	print "</li>\n";
	return;
}

